Subject: Re: List of Service Types

From: Robert Elz <[email-masked]>
Date: Wed, 07 Aug 2002 00:00:37 +0700

Date:        Tue, 30 Jul 2002 22:57:25 -0700
    From:        Stuart Cheshire <[email-masked]>
    Message-ID:  <[email-masked]>

  | This means that a telnet client can automatically find and display a list 
  | of entities on the network that are advertising that they will accept 
  | telnet connections

Maybe I'm missing something obvious, but using the DNS, how exactly is
that intended to be accomplished?

The DNS is a truly lousy searching protocol, in fact, it is hard to
imagine one worse.   If you know the exact name that you want, it works
just fine.   If you don't, it is completely useless.

So, if there are 4 or 5 telnet servers (or printers to move towards the
more common example that has been being used), we know how to create the
name "_telnet._tcp" (or "_printer._tcp" or whatever) - that's defined by
the protocol in use.

We may know what domain that we're in (in some environments - but assume
we do), we may even know of some other domains we might like to look in
to find things.  Call this "example.com" just for the purposes of
argument here.

So, I need to find X such that "_telnet._tcp.X.example.com" exists.

What's the DNS method to achieve that?   I must have missed that sometime.

  | If you make some future "foobar" product, with which the user can 
  | communicate over an ssh connection, then my ssh client software doesn't 
  | need to know what a "foobar" is, it just needs to know that it can talk 
  | ssh to it. I (as a human being) may know what a "foobar" is, but my ssh 
  | client doesn't need to know.

For ssh that might be true.   For printers, I'm not sure that it is.
I know we get constant queries like "why did that printer print all
my postscript file looking like gibberish (which examined is the
postscript program to generate the printing) ?   Answer: well, that
printer doesn't support postscipt, you need to convert it to xxx
(or use a printer driver to convert it to xxx) first.

Similarly if I'm about to print a photograph, dumping it onto a line
printer (even offering me the choice to print it on "printer number 3")
isn't exactly useful.   The list I'm offered should be just those
printers that are capable of printing the data that I want to print.
The software can (should be able to) do that kind of filtering before
a human gets near the list of choices.

  | There is precedent for this. Every time a new PostScript network printer 
  | comes out, users don't need a new driver for it (at least this is true on 
  | the Mac). As long as the printer speaks PostScript over AppleTalk 
  | properly, the Apple LaserWriter driver can find it and print on it, even 
  | though this particular printer model may not have even existed when the 
  | Apple LaserWriter driver was written.

Yes, this is fine.    But on 98% of the printers like that that we have
installed, my photo will come out in B&W (greytone).   Only one or two
of the printers will actually print colour.   How does the laserwriter
driver do on avoiding letting me (unintentionally anyway) send my nice
colour image to a printer that simply cannot cope?

kre

ps: Stuart, in the IETF we generally don't want to know "Apple's position"
we want to know yours.   It is fine (if you're able) to tell us "Apple is
shipping a product which ..." or even "Apple is about to ship a product
which does ...", but corporate positions don't belong.

---

From: Aidan Williams <[email-masked]>
Date: Wed, 07 Aug 2002 09:59:18 +1000

> that intended to be accomplished?

...

> What's the DNS method to achieve that?   I must have missed that sometime.

The X is actually in a surprising position in the domain name:

   X._telnet._tcp.example.com

Creative use of PTR records allows the set of Xes to be discovered.
Multiple PTRs are returned for _service._proto.domain.name and
displayed in a box.  The user chooses something, a query is
then made for a SRV and the connection established.

http://files.dns-sd.org/draft-cheshire-dnsext-nias.txt, Section 10
has an example.

-- 

regards
	aidan
____
:wq!

Sydney Network Research Lab             [email-masked]
Motorola Australian Research Centre          phone: +61 2 9666 0649
Locked Bag 5028, Botany NSW 1455              phax: +61 2 9666 0501
Australia                            http://marc.labs.mot.com/snrl/